<?php

final class BackendMenu
{
    public function menu($notifyUrl, $backUrl)
    {
        return [
            'enabled' => [
                'title' => __('payment.menu.enabled.on_off', 'bluepayment-gateway-for-woocommerce'),
                'label' => __('payment.menu.enabled.on_off.label', 'bluepayment-gateway-for-woocommerce'),
                'type' => 'select',
                'description' => '<a href="https://platnosci.bm.pl/rejestracja?utm_source=woocommerce_backend_signup" target="_blank"> ' .__('payment.menu.register_account', 'bluepayment-gateway-for-woocommerce') . '</a>',
                'options' => [
                    'no' => __('payment.menu.menu.enabled.option.no', 'bluepayment-gateway-for-woocommerce'),
                    'yes' => __('payment.menu.enabled.option.yes', 'bluepayment-gateway-for-woocommerce'),
                ],
            ],
            'title' => [
                'title' => __('payment.menu.title', 'bluepayment-gateway-for-woocommerce'),
                'type' => 'text',
                'description' => __('payment.menu.title.description', 'bluepayment-gateway-for-woocommerce'),
                'default' => __('payment.menu.title.default', 'bluepayment-gateway-for-woocommerce'),
            ],
            'description' => [
                'title' => __('payment.menu.description', 'bluepayment-gateway-for-woocommerce'),
                'type' => 'textarea',
                'description' => __('payment.menu.description.description', 'bluepayment-gateway-for-woocommerce'),
                'default' => __('payment.menu.description.default', 'bluepayment-gateway-for-woocommerce'),
            ],
            'payment_domain' => [
                'title' => __('payment.menu.domain.title', 'bluepayment-gateway-for-woocommerce'),
                'type' => 'text',
                'description' => __('payment.menu.domain.description', 'bluepayment-gateway-for-woocommerce'),
                'css' => 'width: 100%',
                'default' => 'pay-accept.bm.pl'
            ],
            'status_pending' => [
                'title' => __('payment.menu.status_pending.title', 'bluepayment-gateway-for-woocommerce'),
                'label' => __('payment.menu.status_pending.label', 'bluepayment-gateway-for-woocommerce'),
                'type' => 'select',
                'description' => __('payment.menu.status_pending.description', 'bluepayment-gateway-for-woocommerce'),
                'options' => [
                    'pending' => __('payment.menu.status_pending.options.pending', 'bluepayment-gateway-for-woocommerce'),
                    'on-hold' => __('payment.menu.status_pending.options.on_hold', 'bluepayment-gateway-for-woocommerce'),
                ],
            ],
            'url_notify' => [
                'type' => 'hidden',
                'default' => $notifyUrl,

            ],
            'url_back' => [
                'type' => 'hidden',
                'description' => '',
                'default' => $backUrl,
            ]
        ];
    }
}
